﻿Imports Infragistics.Win.CalcEngine
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Dim bs As New BindingSource
    Dim l As New List(Of abc)
    Dim dt As New DataTable

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        dt.Columns.Add("a", GetType(Decimal))
        dt.Columns("a").DefaultValue = 0
        dt.Columns.Add("b", GetType(Decimal))
        dt.Columns("b").DefaultValue = 0
        dt.Columns.Add("c", GetType(Date))
        dt.Columns("c").AllowDBNull = True

        For x As Int16 = 1 To 30
            Dim z As New abc
            z.a = x
            z.b = x
            l.Add(z)

            dt.Rows.Add({x, x})
        Next

        'bs.DataSource = dt
        bs.DataSource = l

        Me.UltraGrid1.DataSource = bs
        UltraLabel1.Text = UltraCalcManager1.DeferredCalculationsEnabled.ToString()


    End Sub

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout

        Me.UltraGrid1.CalcManager = Me.UltraCalcManager1

        Me.UltraGrid1.DisplayLayout.Override.SummaryFooterCaptionVisible = Infragistics.Win.DefaultableBoolean.False

        With Me.UltraGrid1.DisplayLayout.Bands(0)
            .Columns.Add("d")
            .Columns("d").Formula = "[a] + [b]"

            .Summaries.Add("abc", _
                             Infragistics.Win.UltraWinGrid.SummaryType.Custom, _
                             New SummaryTotals(Me.UltraCalcManager1), _
                             .Columns("a"), _
                             Infragistics.Win.UltraWinGrid.SummaryPosition.Left, _
                             .Columns("a"))
            .Summaries("abc").DisplayFormat = "{0}"
            .Summaries("abc").SummaryDisplayArea = Infragistics.Win.UltraWinGrid.SummaryDisplayAreas.TopFixed
            .Summaries("abc").Appearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True


        End With
    End Sub

#Region "Classes"

    Private Class abc
        Implements System.ComponentModel.IEditableObject

        Private Structure def
            Friend a As Decimal
            Friend b As Decimal
            Friend c As Nullable(Of Date)
        End Structure

        Private _editing As Boolean = False
        Private _data As def
        Private _backup As def

        Public Sub New()
            _data = New def

            With _data
                .a = 0
                .b = 0
            End With
        End Sub

        Public Property a() As Decimal
            Get
                Return _data.a
            End Get
            Set(value As Decimal)
                _data.a = value
            End Set
        End Property

        Public Property b() As Decimal
            Get
                Return _data.b
            End Get
            Set(value As Decimal)
                _data.b = value
            End Set
        End Property

        Public Property c() As Nullable(Of Date)
            Get
                Return _data.c
            End Get
            Set(value As Nullable(Of Date))
                _data.c = value
            End Set
        End Property

        Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
            If Not _editing Then
                _backup = _data
                _editing = True
            End If
        End Sub

        Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
            If _editing Then
                _data = _backup
                _editing = False
            End If
        End Sub

        Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
            If _editing Then
                _backup = Nothing
                _editing = False
            End If
        End Sub

    End Class

    Private Class SummaryTotals
        Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator
        Dim ultraCalcManager As IUltraCalcManager

        Dim invoiced As Decimal = 0
        Dim paid As Decimal = 0

        Friend Sub New(ultraCalcManager As IUltraCalcManager)
            Me.ultraCalcManager = ultraCalcManager
        End Sub

        Friend Sub AggregateCustomSummary(summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, row As Infragistics.Win.UltraWinGrid.UltraGridRow) Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.AggregateCustomSummary
            Me.invoiced += CDec(row.Cells("d").Value)
            Me.paid += CDec(IIf(row.Cells("c").Value IsNot Nothing, row.Cells("d").Value, 0))
        End Sub

        Friend Sub BeginCustomSummary(summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, rows As Infragistics.Win.UltraWinGrid.RowsCollection) Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.BeginCustomSummary
            Dim columnRef As IUltraCalcReference = ultraCalcManager.GetReference("//UltraGrid1/abc/d")
            ultraCalcManager.EnsureCalculated(columnRef, True)

            Me.invoiced = 0
            Me.paid = 0
        End Sub

        Friend Function EndCustomSummary(summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, rows As Infragistics.Win.UltraWinGrid.RowsCollection) As Object Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.EndCustomSummary
            Return String.Format("Invoiced: {0:c2}, Paid {1:c2}, Unpaid {2:c2}", Me.invoiced, Me.paid, Me.invoiced - Me.paid)
        End Function

    End Class
#End Region

    Private Sub UltraButton1_Click(sender As System.Object, e As System.EventArgs) Handles UltraButton1.Click
        UltraCalcManager1.DeferredCalculationsEnabled = (Not UltraCalcManager1.DeferredCalculationsEnabled)
        UltraLabel1.Text = UltraCalcManager1.DeferredCalculationsEnabled.ToString()
        UltraGrid1.Refresh()
    End Sub

    Private Sub UltraGrid1_BeforeEnterEditMode(sender As System.Object, e As System.ComponentModel.CancelEventArgs) Handles UltraGrid1.BeforeEnterEditMode
        UltraCalcManager1.DeferredCalculationsEnabled = True
    End Sub
End Class
